class Pettanr.Views.Author.ShowModule
class Pettanr.Views.Author.ShowModule.Header extends Pettanr.Views.Show.Header
  
  initialize: (options) ->
    super(options)
  
class Pettanr.Views.Author.ShowModule.Scrolls extends Backbone.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
  
  render: () ->
    params = {
      controller: 'scrolls', action: 'by_author', id: @item.get('id'),
      page_size: 5
    }
    @list = Locmare.ListGroup.list(
      params['controller'], params['action'], params
    )
    @list.open(() =>
      pager = Locmare.ListGroupModule.LibModule.Pager.factory(@list.page_status, params)
      filer = new Locmare.Filer({
        item_name: @list.item_name, 
        items: @list.items(), 
        pager: pager
      })
      @listenTo(filer, 'http_get', @http_get)
      this.$el.append(filer.render().el)
    )
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
class Pettanr.Views.Author.ShowModule.PanelsBody extends Backbone.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
  
  render: () ->
    params = {
      controller: 'panels', action: 'by_author', id: @item.get('id'),
      page_size: 5
    }
    @list = Locmare.ListGroup.list(
      params['controller'], params['action'], params
    )
    @list.open(() =>
      pager = Locmare.ListGroupModule.LibModule.Pager.factory(@list.page_status, params)
      _.each @list.items(), (panel) =>
        panel = panel.with_elements() # retake panel for 'with_elements' mode
        panel.fetch({cache: false}).done =>
          panel.attributes = panel.replaced_attributes()
          body = new Pettanr.Views.Panel.Body({
            panel: panel,
            spot: null
          })
          @trigger('ready', panel)
          this.$el.append(body.render().el)
    )
    this
  
class Pettanr.Views.Author.ShowModule.Panels extends Backbone.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
    @panels_body = new Pettanr.Views.Author.ShowModule.PanelsBody({item: @item})
    @credits = new Pettanr.Views.Scroll.PlayModule.Credits({parent: this})
  
  render: () ->
    @listenTo(@panels_body, 'ready', @ready)
    @listenTo(@panels_body, 'http_get', @http_get)
    @listenTo(@credits, 'click:credit:icon', @click_credit_icon)
    this.$el.append(@panels_body.render().el)
    this.$el.append(@credits.render().el)
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
  ready: (panel) ->
    @credits.push(panel.licensed_pictures())
  
  click_credit_icon: (item) ->
    @trigger('http_get', item.show_url())
  
class Pettanr.Views.Author.ShowModule.Body extends Backbone.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
    @scrolls = new Pettanr.Views.Author.ShowModule.Scrolls({item: @item})
    @panels = new Pettanr.Views.Author.ShowModule.Panels({item: @item})
  
  render: () ->
    this.$el.html('')
    @listenTo(@scrolls, 'http_get', @http_get)
    @listenTo(@panels, 'http_get', @http_get)
    this.$el.append(@scrolls.render().el)
    this.$el.append(@panels.render().el)
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
class Pettanr.Views.Author.Show extends Backbone.View
  tagName: 'div'
  
  initialize: (options) ->
    @item = options.item
    @header = new Pettanr.Views.Author.ShowModule.Header({
      item: @item, 
      caption: @item.get('name'), 
      icon_url: @item.show_url(),
      caption_url: @item.show_url(),
      prof_url: @item.prof_url()
    })
    @body = new Pettanr.Views.Author.ShowModule.Body({
      item: @item, 
    })
    @listenTo(@body, 'http_get', @http_get)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@header.render().el)
    this.$el.append(@body.render().el)
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
