class Pettanr.Views.SpeechBalloon.Element extends Backbone.View
  tagName: 'div'
  className: 'pettanr-comic-balloon'
  
  initialize: (options) ->
    @element = options.element
    @root = options.root
    @spot = options.spot
    @add_element()
  
  add_element: () ->
    @add_balloon()
    @add_speech()
  
  add_balloon: () ->
    @balloon = @element.get('balloon')
    @set_style()
    klass = @balloon_class()
    @balloon_view = new klass({
      parent: this, 
      element: @balloon, 
      root: @root,
      spot: @spot
    })
  
  add_speech: () ->
    @speech = @element.get('speech')
    klass = @speech_class()
    @speech_view = new klass({
      parent: this, 
      element: @speech, 
      root: @root,
      spot: @spot
    })
  
  clear: () ->
    this
  
  render: () ->
    this.$el.html('')
    this.$el.append(@balloon_view.clear().el)
    this.$el.append(@speech_view.render().el)
    @set_style()
    @balloon_view.render()
    this
  
  set_style: () ->
    attr = {style: Pettanr.to_style(@style())}
    this.$el.attr(attr)
  
  style: () ->
    {
      width: Pettanr.to_s(@balloon.get('width')) + 'px', 
      height: Pettanr.to_s(@balloon.get('height')) + 'px',
      top: Pettanr.to_s(@balloon.get('y')) + 'px',
      left: Pettanr.to_s(@balloon.get('x')) + 'px',
      'z-index': @element.get('z')
    }
  
  balloon_class: () ->
    Pettanr.Views.Balloon.Element
  
  speech_class: () ->
    Pettanr.Views.Speech.Element
  
class Pettanr.Views.SpeechBalloon.Element.Edit extends Pettanr.Views.SpeechBalloon.Element
  
  initialize: (options) ->
    super(options)
    @listenTo(@element, 'sort', @set_style)
    @listenTo(@element, 'active', @active)
    @listenTo(@element, 'inactive', @inactive)
  
  render: () ->
    super()
    @listenTo(@balloon, 'input:r', @input_r)
    @listenTo(@balloon, 'input:x', @set_style)
    @listenTo(@balloon, 'input:y', @set_style)
    @listenTo(@balloon, 'input:width', @set_style)
    @listenTo(@balloon, 'input:height', @set_style)
    bln = @balloon
    this.$el.draggable {
      stop: (event, ui) ->
        left = Math.floor($(@).position().left)
        top = Math.floor($(@).position().top)
        bln.set({x: left, y: top}, {silent: true})
        bln.trigger('move')
    }
    this
  
  set_style: () ->
    super()
  
  input_r: () ->
    @trigger('input:r')
  
  active: () ->
    $('.ui-resizable-handle', this.el).map ->
      $(@).css('display', 'block')
  
  inactive: () ->
    $('.ui-resizable-handle', this.el).map ->
      $(@).css('display', 'none')
  
  element_class: (element) ->
    Pettanr.Views[element.singular()].Element.Edit
  
  balloon_class: () ->
    Pettanr.Views.Balloon.Element.Edit
  
  speech_class: () ->
    Pettanr.Views.Speech.Element.Edit
  
