class StorySheet < Peta::Leaf
  load_manifest
  belongs_to :story
  belongs_to :sheet
  
  validates :story_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :sheet_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
  
  def supply_default
    self.story_id = nil
    self.sheet_id = nil
    self.t = nil
  end
  
  def overwrite operators
  end
  
  def self.public_list_where list
    'stories.visible > 0'
  end
  
  def self.by_author_list_includes
    {
      :story => {
        :author => {}
      }
    }
  end
  
  def self.show_opt
    {:include => {
      :story => {}, 
      :sheet => {
        :author => {} 
      }
    }}
  end
  
  def allow? operators
    return nil if self.story_id == nil or self.sheet_id == nil
    self.story.own?(operators) and self.sheet.usable?(operators)
  end
  
end
