require_dependency "locmare/list_group/list/base"
require_dependency "locmare/list_group/list/public"
require_dependency "locmare/list_group/list/system_resource"
require_dependency "locmare/list_group/list/filter"
require_dependency "locmare/list_group/list/through_filter"
require_dependency "locmare/list_group/list/foreign_filter"
require_dependency "locmare/list_group/list/play"
require_dependency "locmare/list_group/lib"
module Locmare
  class ListGroup
    include ListGroupModule
    include LibModule
    
    def self.types
      {
        'public' => PublicList, 'system_resource' => SystemResourceList,
        'filter' => FilterList, 'through_filter' => ThroughFilterList, 'foreign_filter' => ForeignFilterList, 
        'play' => PlayList
      }
    end
    
    def self.list controller_name, action_name, operators, options = {}
      controller_manifest = Manifest.manifest.controllers[controller_name]
      action_manifest = controller_manifest.actions[action_name]
      if action_manifest.alias
        options['order'] ||= action_manifest.order
        options['direction'] ||= action_manifest.direction
        alias_action = action_manifest.alias_action
        ::Locmare::ListGroup.list alias_action.path_name, alias_action.name, operators, options
      else
        list_group_manifest = LocalManifest.manifest.list_groups[controller_name]
        list_manifest = list_group_manifest.lists[action_name]
        self.types[list_manifest.type].new controller_name, action_name, operators, options
      end
    end
    
  end
end

