# -*- encoding: utf-8 -*-
FactoryGirl.define do
  factory :scroll_hello, :class => Scroll do |i|
    i.title 'おめざめ2'
    i.description 'とうとうあいつが目覚めたぞ。その勇姿をご覧あれ。'
    i.visible 1
    #association :author, factory: :author_yas
    trait :with_scroll_panels do
      after(:create) do |scroll, evaluator|
        create(:scroll_panel_plain, t: 0, scroll: scroll, panel: create(:panel_hello, author: scroll.author))
        create(:scroll_panel_plain, t: 1, scroll: scroll, panel: create(:panel_my_name, author: scroll.author))
        create(:scroll_panel_plain, t: 2, scroll: scroll, panel: create(:panel_penjiro, author: scroll.author))
        create(:scroll_panel_plain, t: 3, scroll: scroll, panel: create(:panel_enjoy, author: scroll.author))
      end
    end
    factory :scroll_hello_with_scroll_panels, traits: [:with_scroll_panels]
  end
  factory :scroll_hidden, :class => Scroll do |i|
    i.title '非公開のスクロール'
    i.description '非公開の状態で作成したり、公開スクロールを非公開に変えるときに使う。'
    i.visible 0
  end
  factory :scroll_itojun, :class => Scroll do |i|
    i.title 'aaaaaaaa'
    i.description ''
    i.visible 1
  end
  factory :scroll_great, :class => Scroll do |i|
    i.title 'aaaaaaaa'
    i.description ''
    i.visible 1
    trait :with_scroll_panels do
      after(:create) do |scroll, evaluator|
        create(:scroll_panel_plain, t: 0, scroll: scroll, panel: create(:panel_great, author: scroll.author))
        create(:scroll_panel_plain, t: 1, scroll: scroll, panel: create(:panel_awesome, author: scroll.author))
        create(:scroll_panel_plain, t: 2, scroll: scroll, panel: create(:panel_wonderful, author: scroll.author))
      end
    end
    factory :scroll_great_with_scroll_panels, traits: [:with_scroll_panels]
  end
  factory :scroll_diary, :class => Scroll do |i|
    i.title '投稿した直後'
    i.description ''
    i.visible 1
  end
  factory :scroll006, :class => Scroll do |i|
    i.title '投稿した直後'
    i.description ''
    i.visible 1
    i.author_id 1
  end
  factory :scroll007, :class => Scroll do |i|
    i.title '「はてなブックマーク」が、重すぎる'
    i.description 'zzzz'
    i.visible 1
    i.author_id 1
  end
  factory :scroll008, :class => Scroll do |i|
    i.title '投稿した直後2'
    i.description 'qwe'
    i.visible 1
    i.author_id 1
  end
end
